
#include "../includes/settingsModule.h"
#include <errno.h>

//Init the structs - Not sure if any of these are acutally needed any more (they arn't connected to anything)
systemSettings sysSettings = {
    .systemName = DEF_SYSTEM_NAME,
};

//Hanlder structs
struct settings_handler systemSettings_conf = {
    .name = "system",
    .h_get = NULL,
    .h_set = system_handle_set,
    .h_commit = NULL,
    .h_export = system_handle_export
};

//System Handler Functions
int system_handle_set(const char *name, size_t len, settings_read_cb read_cb, void *cb_arg){
    const char *next;
    int rc;
    //LTE Enabled
    if (settings_name_steq(name, "lteEnabled", &next) && !next){
        if (len != sizeof(sysSettings.lteEnabled)) {
            return -EINVAL;
        }
        rc = read_cb(cb_arg, &sysSettings.lteEnabled, sizeof(sysSettings.lteEnabled));
        if (rc >= 0){
            return 0;
        }
        return rc;
    }
    //System Name
    if (settings_name_steq(name, "systemName", &next) && !next){
        if (len != sizeof(sysSettings.systemName)) {
            return -EINVAL;
        }
        rc = read_cb(cb_arg, &sysSettings.systemName, sizeof(sysSettings.systemName));
        if (rc>=0){
            return 0;
        }
        return rc;
    }
}

int system_handle_export(int (*cb)(const char *name, const void *value, size_t val_len)){
    (void)cb("system/lteEnabled", &sysSettings.lteEnabled, sizeof(sysSettings.lteEnabled));
    (void)cb("system/systemName", &sysSettings.systemName, sizeof(sysSettings.systemName));
    return 0;
}

//External use functions
int init_settings(){
    int rc;
    rc = settings_subsys_init();
    rc = settings_register(&systemSettings_conf);
    rc = settings_load();
    rc = settings_save();
    if (rc){
        //Should add log here perhaps
        return rc;
    }
    return 0;
}