#ifndef RTCHELPER_H
#define RTCHELPER_H

#include <zephyr/sys/timeutil.h>
#include <zephyr/shell/shell.h>
#include <stdio.h>
#include <zephyr/device.h>
#include <zephyr/logging/log.h>

#define RTCNode DT_NODELABEL(pcf8523)

//Overview Struct
struct RTCState{
    bool timeValid;
    bool clkOutEn;
};
extern struct RTCState *boardRTCState;

int RTCgetTime(uint64_t *buffer);
int RTCsetTime(const uint64_t *timestamp);
int RTCenableCLKout();
int RTCdisableCLKout();
int RTCsetINTAlarm(uint64_t *alarmTime);
int RTCsetPSCountdown(int hours);

void RTCclearTimerBInterupt();

int __shell_RTC_Get_Time(const struct shell *sh, size_t argc, char **argv);
int __shell_RTC_Set_Time(const struct shell *sh, size_t argc, char **argv);
int __shell_RTC_EnableCLKOut(const struct shell *sh, size_t argc, char **argv);
int __shell_RTC_DisableCLKOut(const struct shell *sh, size_t argc, char **argv);
int __shell_RTC_DUMP(const struct shell *sh, size_t argc, char **argv);
int __shell_RTC_alarmTest(const struct shell *sh, size_t argc, char **argv);

#endif